Index: /branches/PerformanceComparison/HeuristicLab.Analysis/3.3/Optimizers/IRRRun.cs
===================================================================
--- /branches/PerformanceComparison/HeuristicLab.Analysis/3.3/Optimizers/IRRRun.cs	(revision 12803)
+++ /branches/PerformanceComparison/HeuristicLab.Analysis/3.3/Optimizers/IRRRun.cs	(revision 12803)
@@ -0,0 +1,560 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2012 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System;
+using System.Collections.Generic;
+using System.ComponentModel;
+using System.Drawing;
+using System.Linq;
+using HeuristicLab.Common;
+using HeuristicLab.Common.Resources;
+using HeuristicLab.Core;
+using HeuristicLab.Data;
+using HeuristicLab.Optimization;
+using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
+
+namespace HeuristicLab.Analysis {
+  public enum TerminationCriterium { OnlyByTime, OnlyByEvaluations, OnlyByTarget, ByTargetAndTime, ByTargetAndEvaluations, WhicheverHitsFirst, WhicheverHitsLast }
+  /// <summary>
+  /// A run in which an algorithm is executed for a certain maximum time only.
+  /// </summary>
+  [Item("Independent Random Restart Run", "A run in which an optimizer is repeated until either a certain target value is reached or a maximum budget is exceeded.")]
+  [Creatable(CreatableAttribute.Categories.TestingAndAnalysis, Priority = 117)]
+  [StorableClass]
+  public sealed class IndepdentRandomRestartRun : NamedItem, IOptimizer, IStorableContent, INotifyPropertyChanged {
+    public string Filename { get; set; }
+
+    #region ItemImage
+    public static new Image StaticItemImage {
+      get { return VSImageLibrary.Event; }
+    }
+    public override Image ItemImage {
+      get { return (Algorithm != null) ? Algorithm.ItemImage : VSImageLibrary.ExecutableStopped; }
+    }
+    #endregion
+
+    [Storable]
+    private TerminationCriterium terminationCriterium;
+    public TerminationCriterium TerminationCriterium {
+      get { return terminationCriterium; }
+      set {
+        if (terminationCriterium == value) return;
+        terminationCriterium = value;
+        OnPropertyChanged("TerminationCriterium");
+      }
+    }
+
+    [Storable]
+    private TimeSpan maximumExecutionTime;
+    public TimeSpan MaximumExecutionTime {
+      get { return maximumExecutionTime; }
+      set {
+        if (maximumExecutionTime == value) return;
+        maximumExecutionTime = value;
+        OnPropertyChanged("MaximumExecutionTime");
+      }
+    }
+
+    [Storable]
+    private int maximumEvaluations;
+    public int MaximumEvaluations {
+      get { return maximumEvaluations; }
+      set {
+        if (maximumEvaluations == value) return;
+        maximumEvaluations = value;
+        OnPropertyChanged("MaximumEvaluations");
+      }
+    }
+
+    [Storable]
+    private double targetValue;
+    public double TargetValue {
+      get { return targetValue; }
+      set {
+        if (targetValue == value) return;
+        targetValue = value;
+        OnPropertyChanged("TargetValue");
+      }
+    }
+
+    [Storable]
+    private bool maximization;
+    public bool Maximization {
+      get { return maximization; }
+      private set {
+        if (maximization == value) return;
+        maximization = value;
+        OnPropertyChanged("Maximization");
+      }
+    }
+
+    [Storable]
+    private double moveCostPerSolution;
+    public double MoveCostPerSolution {
+      get { return moveCostPerSolution; }
+      set {
+        if (moveCostPerSolution == value) return;
+        moveCostPerSolution = value;
+        OnPropertyChanged("MoveCostPerSolution");
+      }
+    }
+
+
+    public ExecutionState ExecutionState {
+      get { return (Algorithm != null) ? Algorithm.ExecutionState : ExecutionState.Stopped; }
+    }
+
+    private TimeSpan lastAlgorithmExecutionTime;
+    [Storable]
+    private TimeSpan executionTime;
+    public TimeSpan ExecutionTime {
+      get { return executionTime; }
+      set {
+        if (executionTime == value) return;
+        executionTime = value;
+        OnPropertyChanged("ExecutionTime");
+        OnExecutionTimeChanged();
+      }
+    }
+
+    private int lastAlgorithmEvaluatedSolutions;
+    private int lastAlgorithmEvaluatedMoves;
+    [Storable]
+    private double evaluations;
+    public double Evaluations {
+      get { return evaluations; }
+      set {
+        if (evaluations == value) return;
+        evaluations = value;
+        OnPropertyChanged("Evaluations");
+      }
+    }
+
+    [Storable]
+    private double bestSoFar;
+    public double BestSoFar {
+      get { return bestSoFar; }
+      set {
+        if (bestSoFar == value) return;
+        bestSoFar = value;
+        OnPropertyChanged("BestSoFar");
+      }
+    }
+
+    [Storable]
+    private IRun currentRun;
+    public IRun CurrentRun {
+      get { return currentRun; }
+      private set {
+        if (currentRun == value) return;
+        currentRun = value;
+        OnPropertyChanged("CurrentRun");
+      }
+    }
+
+    [Storable]
+    private IAlgorithm algorithm;
+    public IAlgorithm Algorithm {
+      get { return algorithm; }
+      set {
+        if (algorithm == value) return;
+        if (algorithm != null) DeregisterAlgorithmEvents();
+        algorithm = value;
+        if (algorithm != null) {
+          RegisterAlgorithmEvents();
+        }
+        OnPropertyChanged("Algorithm");
+        Prepare();
+      }
+    }
+
+    [Storable]
+    private RunCollection runs;
+    public RunCollection Runs {
+      get { return runs; }
+      private set {
+        if (value == null) throw new ArgumentNullException();
+        if (runs == value) return;
+        runs = value;
+        OnPropertyChanged("Runs");
+      }
+    }
+
+    public IEnumerable<IOptimizer> NestedOptimizers {
+      get {
+        if (Algorithm == null) yield break;
+        yield return Algorithm;
+        foreach (var opt in Algorithm.NestedOptimizers)
+          yield return opt;
+      }
+    }
+
+    private bool IsFinished {
+      get {
+        var timeHit = ExecutionTime >= MaximumExecutionTime;
+        var evalHit = Evaluations >= MaximumEvaluations;
+        var targetHit = (Maximization && BestSoFar >= TargetValue || !Maximization && BestSoFar <= TargetValue);
+
+        return timeHit && evalHit && targetHit
+          || timeHit && (TerminationCriterium == TerminationCriterium.OnlyByTime
+                      || TerminationCriterium == TerminationCriterium.ByTargetAndTime
+                      || TerminationCriterium == TerminationCriterium.WhicheverHitsFirst)
+          || evalHit && (TerminationCriterium == TerminationCriterium.OnlyByEvaluations
+                      || TerminationCriterium == TerminationCriterium.ByTargetAndEvaluations
+                      || TerminationCriterium == TerminationCriterium.WhicheverHitsFirst)
+          || targetHit && (TerminationCriterium == TerminationCriterium.OnlyByTarget
+                        || TerminationCriterium == TerminationCriterium.WhicheverHitsFirst
+                        || TerminationCriterium == TerminationCriterium.ByTargetAndTime
+                        || TerminationCriterium == TerminationCriterium.ByTargetAndEvaluations);
+      }
+    }
+
+    [StorableConstructor]
+    private IndepdentRandomRestartRun(bool deserializing) : base(deserializing) { }
+    private IndepdentRandomRestartRun(IndepdentRandomRestartRun original, Cloner cloner)
+      : base(original, cloner) {
+      terminationCriterium = original.terminationCriterium;
+      maximumExecutionTime = original.maximumExecutionTime;
+      maximumEvaluations = original.maximumEvaluations;
+      targetValue = original.targetValue;
+      executionTime = original.executionTime;
+      evaluations = original.evaluations;
+      bestSoFar = original.bestSoFar;
+      lastAlgorithmExecutionTime = original.lastAlgorithmExecutionTime;
+      lastAlgorithmEvaluatedSolutions = original.lastAlgorithmEvaluatedSolutions;
+      lastAlgorithmEvaluatedMoves = original.lastAlgorithmEvaluatedMoves;
+
+      algorithm = cloner.Clone(original.algorithm);
+      runs = cloner.Clone(original.runs);
+
+      Initialize();
+    }
+    public IndepdentRandomRestartRun()
+      : base() {
+      name = ItemName;
+      description = ItemDescription;
+      terminationCriterium = TerminationCriterium.OnlyByEvaluations;
+      maximumExecutionTime = TimeSpan.FromMinutes(1);
+      maximumEvaluations = 10000000; // 10 mio
+      targetValue = 0;
+      executionTime = TimeSpan.Zero;
+      evaluations = 0;
+      bestSoFar = double.NaN;
+      lastAlgorithmExecutionTime = TimeSpan.Zero;
+      lastAlgorithmEvaluatedSolutions = 0;
+      lastAlgorithmEvaluatedMoves = 0;
+
+      Runs = new RunCollection { OptimizerName = Name };
+      Initialize();
+    }
+    public IndepdentRandomRestartRun(string name)
+      : base(name) {
+      description = ItemDescription;
+      terminationCriterium = TerminationCriterium.OnlyByEvaluations;
+      maximumExecutionTime = TimeSpan.FromMinutes(1);
+      maximumEvaluations = 10000000; // 10 mio
+      targetValue = 0;
+      executionTime = TimeSpan.Zero;
+      evaluations = 0;
+      bestSoFar = double.NaN;
+      lastAlgorithmExecutionTime = TimeSpan.Zero;
+      lastAlgorithmEvaluatedSolutions = 0;
+      lastAlgorithmEvaluatedMoves = 0;
+
+      Runs = new RunCollection { OptimizerName = Name };
+      Initialize();
+    }
+    public IndepdentRandomRestartRun(string name, string description)
+      : base(name, description) {
+      terminationCriterium = TerminationCriterium.OnlyByEvaluations;
+      maximumExecutionTime = TimeSpan.FromMinutes(1);
+      maximumEvaluations = 10000000; // 10 mio
+      targetValue = 0;
+      executionTime = TimeSpan.Zero;
+      evaluations = 0;
+      bestSoFar = double.NaN;
+      lastAlgorithmExecutionTime = TimeSpan.Zero;
+      lastAlgorithmEvaluatedSolutions = 0;
+      lastAlgorithmEvaluatedMoves = 0;
+
+      Runs = new RunCollection { OptimizerName = Name };
+      Initialize();
+    }
+
+    public override IDeepCloneable Clone(Cloner cloner) {
+      if (ExecutionState == ExecutionState.Started) throw new InvalidOperationException(string.Format("Clone not allowed in execution state \"{0}\".", ExecutionState));
+      return new IndepdentRandomRestartRun(this, cloner);
+    }
+
+    [StorableHook(HookType.AfterDeserialization)]
+    private void AfterDeserialization() {
+      Initialize();
+    }
+
+    private void Initialize() {
+      if (algorithm != null) RegisterAlgorithmEvents();
+    }
+
+    public void Prepare() {
+      Prepare(false);
+    }
+    public void Prepare(bool clearRuns) {
+      executionTime = TimeSpan.Zero;
+      evaluations = 0;
+      lastAlgorithmExecutionTime = TimeSpan.Zero;
+      lastAlgorithmEvaluatedSolutions = 0;
+
+      Algorithm.Prepare(clearRuns);
+    }
+    public void Start() {
+      if (ExecutionState == ExecutionState.Prepared) {
+        currentRun = new Run(Algorithm) {
+          Name = Algorithm.Name + " IRRRun" + Runs.Count
+        };
+      }
+      Algorithm.Start();
+    }
+    public void Pause() {
+      Algorithm.Pause();
+    }
+    public void Stop() {
+      Algorithm.Stop();
+    }
+
+    #region Events
+    protected override void OnNameChanged() {
+      base.OnNameChanged();
+      runs.OptimizerName = Name;
+    }
+
+    public event PropertyChangedEventHandler PropertyChanged;
+    private void OnPropertyChanged(string property) {
+      var handler = PropertyChanged;
+      if (handler != null) handler(this, new PropertyChangedEventArgs(property));
+    }
+
+    #region IExecutable Events
+    public event EventHandler ExecutionStateChanged;
+    private void OnExecutionStateChanged() {
+      var handler = ExecutionStateChanged;
+      if (handler != null) handler(this, EventArgs.Empty);
+    }
+    public event EventHandler ExecutionTimeChanged;
+    private void OnExecutionTimeChanged() {
+      var handler = ExecutionTimeChanged;
+      if (handler != null) handler(this, EventArgs.Empty);
+    }
+    public event EventHandler Prepared;
+    private void OnPrepared() {
+      var handler = Prepared;
+      if (handler != null) handler(this, EventArgs.Empty);
+    }
+    public event EventHandler Started;
+    private void OnStarted() {
+      var handler = Started;
+      if (handler != null) handler(this, EventArgs.Empty);
+    }
+    public event EventHandler Paused;
+    private void OnPaused() {
+      var handler = Paused;
+      if (handler != null) handler(this, EventArgs.Empty);
+    }
+    public event EventHandler Stopped;
+    private void OnStopped() {
+      var handler = Stopped;
+      if (handler != null) handler(this, EventArgs.Empty);
+    }
+    public event EventHandler<EventArgs<Exception>> ExceptionOccurred;
+    private void OnExceptionOccurred(Exception exception) {
+      var handler = ExceptionOccurred;
+      if (handler != null) handler(this, new EventArgs<Exception>(exception));
+    }
+    #endregion
+
+    #region Algorithm Events
+    private void RegisterAlgorithmEvents() {
+      algorithm.ExceptionOccurred += Algorithm_ExceptionOccurred;
+      algorithm.ExecutionTimeChanged += Algorithm_ExecutionTimeChanged;
+      algorithm.ExecutionStateChanged += Algorithm_ExecutionStateChanged;
+      algorithm.Paused += Algorithm_Paused;
+      algorithm.Prepared += Algorithm_Prepared;
+      algorithm.Started += Algorithm_Started;
+      algorithm.Stopped += Algorithm_Stopped;
+      algorithm.ProblemChanged += Algorithm_ProblemChanged;
+    }
+    private void DeregisterAlgorithmEvents() {
+      algorithm.ExceptionOccurred -= Algorithm_ExceptionOccurred;
+      algorithm.ExecutionTimeChanged -= Algorithm_ExecutionTimeChanged;
+      algorithm.ExecutionStateChanged -= Algorithm_ExecutionStateChanged;
+      algorithm.Paused -= Algorithm_Paused;
+      algorithm.Prepared -= Algorithm_Prepared;
+      algorithm.Started -= Algorithm_Started;
+      algorithm.Stopped -= Algorithm_Stopped;
+      algorithm.ProblemChanged -= Algorithm_ProblemChanged;
+    }
+    private void Algorithm_ExceptionOccurred(object sender, EventArgs<Exception> e) {
+      OnExceptionOccurred(e.Value);
+    }
+    private void Algorithm_ExecutionTimeChanged(object sender, EventArgs e) {
+      ExecutionTime += Algorithm.ExecutionTime - lastAlgorithmExecutionTime;
+      lastAlgorithmExecutionTime = Algorithm.ExecutionTime;
+
+      UpdateAlgorithmResults();
+
+      if (IsFinished) {
+        Algorithm.Stop();
+      }
+      OnExecutionTimeChanged();
+    }
+
+    private void Algorithm_ExecutionStateChanged(object sender, EventArgs e) {
+      OnExecutionStateChanged();
+    }
+    private void Algorithm_Paused(object sender, EventArgs e) {
+      ExecutionTime += Algorithm.ExecutionTime - lastAlgorithmExecutionTime;
+      lastAlgorithmExecutionTime = Algorithm.ExecutionTime;
+
+      UpdateAlgorithmResults();
+      OnPaused();
+    }
+    private void Algorithm_Prepared(object sender, EventArgs e) {
+      OnPrepared();
+    }
+    private void Algorithm_Started(object sender, EventArgs e) {
+      OnStarted();
+    }
+    private void Algorithm_Stopped(object sender, EventArgs e) {
+      ExecutionTime += Algorithm.ExecutionTime - lastAlgorithmExecutionTime;
+      lastAlgorithmExecutionTime = Algorithm.ExecutionTime;
+
+      var bestQuality = UpdateAlgorithmResults();
+
+      foreach (var result in Algorithm.Results) {
+        if (result.Name == "QualityPerClock") {
+          if (!currentRun.Results.ContainsKey(result.Name))
+            currentRun.Results.Add(result.Name, (IItem)result.Value.Clone());
+          else {
+            var dt = (IndexedDataTable<double>)currentRun.Results[result.Name];
+            var execTime = ((TimeSpanValue)currentRun.Results["ExecutionTime"]).Value.TotalSeconds;
+            var best = dt.Rows.First().Values.Last().Item2;
+            var resultDt = (IndexedDataTable<double>)result.Value;
+            foreach (var tupl in resultDt.Rows.First().Values) {
+              if (Maximization && tupl.Item2 > best || !Maximization && tupl.Item2 < best) {
+                dt.Rows.First().Values.Add(Tuple.Create(execTime + tupl.Item1, tupl.Item2));
+                best = tupl.Item2;
+              }
+            }
+          }
+        } else if (result.Name == "QualityPerEvaluations") {
+          if (!currentRun.Results.ContainsKey(result.Name))
+            currentRun.Results.Add(result.Name, (IItem)result.Value.Clone());
+          else {
+            var dt = (IndexedDataTable<double>)currentRun.Results[result.Name];
+            var evalSols = ((DoubleValue)currentRun.Results["EvaluatedSolutions"]).Value;
+            var evalMoves = ((DoubleValue)currentRun.Results["EvaluatedMoves"]).Value;
+            var best = dt.Rows.First().Values.Last().Item2;
+            var resultDt = (IndexedDataTable<double>)result.Value;
+            foreach (var tupl in resultDt.Rows.First().Values) {
+              if (Maximization && tupl.Item2 > best || !Maximization && tupl.Item2 < best) {
+                dt.Rows.First().Values.Add(Tuple.Create(evalSols + moveCostPerSolution * evalMoves + tupl.Item1, tupl.Item2));
+                best = tupl.Item2;
+              }
+            }
+          }
+        } else if (result.Name == "EvaluatedSolutions") {
+          currentRun.Results.Add(result.Name, (IItem)result.Value.Clone());
+        } else if (result.Name == "EvaluatedMoves") {
+          currentRun.Results.Add(result.Name, (IItem)result.Value.Clone());
+        } else if (result.Name == "ExecutionTime") {
+          currentRun.Results.Add(result.Name, (IItem)result.Value.Clone());
+        } else if (result.Name == "BestQuality") {
+          currentRun.Results.Add(result.Name, (IItem)result.Value.Clone());
+        } else if (result.Name.ToLower().EndsWith("solution") && BestSoFar == bestQuality) {
+          currentRun.Results.Add(result.Name, (IItem)result.Value.Clone());
+        }
+      }
+      foreach (var result in Algorithm.Results) {
+        if (result.Name == "QualityPerClock") {
+
+        } else if (result.Name == "QualityPerEvaluations") {
+        } else if (result.Name == "EvaluatedSolutions") {
+          currentRun.Results.Add(result.Name, (IItem)result.Value.Clone());
+        } else if (result.Name == "EvaluatedMoves") {
+          currentRun.Results.Add(result.Name, (IItem)result.Value.Clone());
+        } else if (result.Name == "ExecutionTime") {
+          currentRun.Results.Add(result.Name, (IItem)result.Value.Clone());
+        } else if (result.Name == "BestQuality") {
+          currentRun.Results.Add(result.Name, (IItem)result.Value.Clone());
+        } else if (result.Name.ToLower().EndsWith("solution") && BestSoFar == bestQuality) {
+          currentRun.Results.Add(result.Name, (IItem)result.Value.Clone());
+        }
+      }
+
+
+      if (IsFinished) {
+
+      }
+
+      // TODO
+      var cloner = new Cloner();
+      var algRun = cloner.Clone(Algorithm.Runs.Last());
+      Runs.Add(algRun);
+      Algorithm.Runs.Clear();
+      OnStopped();
+    }
+
+    private double UpdateAlgorithmResults() {
+      IResult evaluationsResult;
+      if (Algorithm.Results.TryGetValue("EvaluatedSolutions", out evaluationsResult)) {
+        var evals = ((IntValue)evaluationsResult.Value).Value;
+        Evaluations += evals - lastAlgorithmEvaluatedSolutions;
+        lastAlgorithmEvaluatedSolutions = evals;
+      }
+      if (Algorithm.Results.TryGetValue("EvaluatedMoves", out evaluationsResult)) {
+        var evals = ((IntValue)evaluationsResult.Value).Value;
+        Evaluations += moveCostPerSolution * (evals - lastAlgorithmEvaluatedMoves);
+        lastAlgorithmEvaluatedMoves = evals;
+      }
+      if (Algorithm.Results.TryGetValue("BestQuality", out evaluationsResult)) {
+        var bestQuality = ((DoubleValue)evaluationsResult).Value;
+        if (double.IsNaN(BestSoFar)
+            || Maximization && bestQuality > BestSoFar
+            || !Maximization && bestQuality < BestSoFar)
+          BestSoFar = bestQuality;
+        return bestQuality;
+      }
+      return double.NaN;
+    }
+
+    private void Algorithm_ProblemChanged(object sender, EventArgs e) {
+      var soProblem = Algorithm.Problem as ISingleObjectiveHeuristicOptimizationProblem;
+      if (soProblem == null) return;
+      var maxParam = soProblem.MaximizationParameter as IValueParameter<BoolValue>;
+      if (maxParam != null)
+        Maximization = maxParam.Value.Value;
+      var bkParam = soProblem.BestKnownQualityParameter as IValueParameter<DoubleValue>;
+      if (bkParam != null && bkParam.Value != null)
+        TargetValue = bkParam.Value.Value;
+    }
+    #endregion
+    #endregion
+  }
+}
Index: /branches/PerformanceComparison/HeuristicLab.Analysis/3.3/QualityAnalysis/QualityPerClockAnalyzer.cs
===================================================================
--- /branches/PerformanceComparison/HeuristicLab.Analysis/3.3/QualityAnalysis/QualityPerClockAnalyzer.cs	(revision 12802)
+++ /branches/PerformanceComparison/HeuristicLab.Analysis/3.3/QualityAnalysis/QualityPerClockAnalyzer.cs	(revision 12803)
@@ -42,6 +42,6 @@
     }
 
-    public IResultParameter<TimeSpanValue> ExecutionTimeParameter {
-      get { return (IResultParameter<TimeSpanValue>)Parameters["Execution Time"]; }
+    public ILookupParameter<DateTimeValue> LastUpdateTimeParameter {
+      get { return (ILookupParameter<DateTimeValue>)Parameters["LastUpdateTime"]; }
     }
 
@@ -56,5 +56,5 @@
       : base() {
       Parameters.Add(new LookupParameter<DoubleValue>("BestQuality", "The quality value that should be compared."));
-      Parameters.Add(new ResultParameter<TimeSpanValue>("Execution Time", "The execution time."));
+      Parameters.Add(new LookupParameter<DateTimeValue>("LastUpdateTime", "The time the analyzer was last run."));
       Parameters.Add(new ResultParameter<IndexedDataTable<double>>("QualityPerClock", "Data table containing the first hitting graph with elapsed wall clock time (in seconds) as the x-axis."));
       QualityPerClockParameter.DefaultValue = new IndexedDataTable<double>("Quality per Clock") {
@@ -75,5 +75,11 @@
 
     public override IOperation Apply() {
-      var executionTime = Math.Max(ExecutionTimeParameter.ResultValue.Value.TotalSeconds, 0.2);
+      var lastUpdateTime = LastUpdateTimeParameter.ActualValue;
+      if (lastUpdateTime == null) {
+        lastUpdateTime = new DateTimeValue(DateTime.UtcNow.AddMilliseconds(-1));
+        LastUpdateTimeParameter.ActualValue = lastUpdateTime;
+      }
+      var now = DateTime.UtcNow;
+
       var bestQuality = BestQualityParameter.ActualValue.Value;
 
@@ -81,6 +87,7 @@
       var values = dataTable.Rows["First-hit Graph"].Values;
       if (values.Count == 0 || values.Last().Item2 != bestQuality)
-        dataTable.Rows["First-hit Graph"].Values.Add(Tuple.Create(executionTime, bestQuality));
+        dataTable.Rows["First-hit Graph"].Values.Add(Tuple.Create((now - lastUpdateTime.Value).TotalSeconds, bestQuality));
 
+      lastUpdateTime.Value = now;
       return base.Apply();
     }
Index: /branches/PerformanceComparison/HeuristicLab.Optimization.Views/3.3/HeuristicLab.Optimization.Views-3.3.csproj
===================================================================
--- /branches/PerformanceComparison/HeuristicLab.Optimization.Views/3.3/HeuristicLab.Optimization.Views-3.3.csproj	(revision 12802)
+++ /branches/PerformanceComparison/HeuristicLab.Optimization.Views/3.3/HeuristicLab.Optimization.Views-3.3.csproj	(revision 12803)
@@ -338,9 +338,9 @@
       <DependentUpon>RunCollectionEqualityConstraintView.cs</DependentUpon>
     </Compile>
-    <Compile Include="RunCollectionViews\RunCollectionECDFView.cs">
-      <SubType>UserControl</SubType>
-    </Compile>
-    <Compile Include="RunCollectionViews\RunCollectionECDFView.Designer.cs">
-      <DependentUpon>RunCollectionECDFView.cs</DependentUpon>
+    <Compile Include="RunCollectionViews\RunCollectionRLDView.cs">
+      <SubType>UserControl</SubType>
+    </Compile>
+    <Compile Include="RunCollectionViews\RunCollectionRLDView.Designer.cs">
+      <DependentUpon>RunCollectionRLDView.cs</DependentUpon>
     </Compile>
     <Compile Include="RunCollectionViews\RunCollectionTableView.cs">
Index: anches/PerformanceComparison/HeuristicLab.Optimization.Views/3.3/RunCollectionViews/RunCollectionECDFView.Designer.cs
===================================================================
--- /branches/PerformanceComparison/HeuristicLab.Optimization.Views/3.3/RunCollectionViews/RunCollectionECDFView.Designer.cs	(revision 12802)
+++ 	(revision )
@@ -1,149 +1,0 @@
-﻿#region License Information
-/* HeuristicLab
- * Copyright (C) 2002-2015 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
- *
- * This file is part of HeuristicLab.
- *
- * HeuristicLab is free software: you can redistribute it and/or modify
- * it under the terms of the GNU General Public License as published by
- * the Free Software Foundation, either version 3 of the License, or
- * (at your option) any later version.
- *
- * HeuristicLab is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
- */
-#endregion
-namespace HeuristicLab.Optimization.Views {
-  partial class RunCollectionECDFView {
-    /// <summary> 
-    /// Required designer variable.
-    /// </summary>
-    private System.ComponentModel.IContainer components = null;
-
-    /// <summary> 
-    /// Clean up any resources being used.
-    /// </summary>
-    /// <param name="disposing">true if managed resources should be disposed; otherwise, false.</param>
-    protected override void Dispose(bool disposing) {
-      if (disposing && (components != null)) {
-        components.Dispose();
-      }
-      base.Dispose(disposing);
-    }
-
-    #region Component Designer generated code
-
-    /// <summary> 
-    /// Required method for Designer support - do not modify 
-    /// the contents of this method with the code editor.
-    /// </summary>
-    private void InitializeComponent() {
-      this.dataTableComboBox = new System.Windows.Forms.ComboBox();
-      this.label1 = new System.Windows.Forms.Label();
-      this.viewHost = new HeuristicLab.MainForm.WindowsForms.ViewHost();
-      this.label2 = new System.Windows.Forms.Label();
-      this.groupComboBox = new System.Windows.Forms.ComboBox();
-      this.logScalingCheckBox = new System.Windows.Forms.CheckBox();
-      this.SuspendLayout();
-      // 
-      // dataTableComboBox
-      // 
-      this.dataTableComboBox.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left) 
-            | System.Windows.Forms.AnchorStyles.Right)));
-      this.dataTableComboBox.DropDownStyle = System.Windows.Forms.ComboBoxStyle.DropDownList;
-      this.dataTableComboBox.FormattingEnabled = true;
-      this.dataTableComboBox.Location = new System.Drawing.Point(69, 30);
-      this.dataTableComboBox.Name = "dataTableComboBox";
-      this.dataTableComboBox.Size = new System.Drawing.Size(455, 21);
-      this.dataTableComboBox.TabIndex = 0;
-      this.dataTableComboBox.SelectedIndexChanged += new System.EventHandler(this.dataTableComboBox_SelectedIndexChanged);
-      // 
-      // label1
-      // 
-      this.label1.AutoSize = true;
-      this.label1.Location = new System.Drawing.Point(3, 33);
-      this.label1.Name = "label1";
-      this.label1.Size = new System.Drawing.Size(60, 13);
-      this.label1.TabIndex = 1;
-      this.label1.Text = "DataTable:";
-      // 
-      // viewHost
-      // 
-      this.viewHost.Anchor = ((System.Windows.Forms.AnchorStyles)((((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom) 
-            | System.Windows.Forms.AnchorStyles.Left) 
-            | System.Windows.Forms.AnchorStyles.Right)));
-      this.viewHost.Caption = "View";
-      this.viewHost.Content = null;
-      this.viewHost.Enabled = false;
-      this.viewHost.Location = new System.Drawing.Point(4, 57);
-      this.viewHost.Name = "viewHost";
-      this.viewHost.ReadOnly = false;
-      this.viewHost.Size = new System.Drawing.Size(520, 291);
-      this.viewHost.TabIndex = 2;
-      this.viewHost.ViewsLabelVisible = true;
-      this.viewHost.ViewType = null;
-      // 
-      // label2
-      // 
-      this.label2.AutoSize = true;
-      this.label2.Location = new System.Drawing.Point(3, 6);
-      this.label2.Name = "label2";
-      this.label2.Size = new System.Drawing.Size(39, 13);
-      this.label2.TabIndex = 3;
-      this.label2.Text = "Group:";
-      // 
-      // groupComboBox
-      // 
-      this.groupComboBox.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left) 
-            | System.Windows.Forms.AnchorStyles.Right)));
-      this.groupComboBox.DropDownStyle = System.Windows.Forms.ComboBoxStyle.DropDownList;
-      this.groupComboBox.FormattingEnabled = true;
-      this.groupComboBox.Location = new System.Drawing.Point(69, 3);
-      this.groupComboBox.Name = "groupComboBox";
-      this.groupComboBox.Size = new System.Drawing.Size(455, 21);
-      this.groupComboBox.TabIndex = 4;
-      this.groupComboBox.SelectedIndexChanged += new System.EventHandler(this.groupComboBox_SelectedIndexChanged);
-      // 
-      // logScalingCheckBox
-      // 
-      this.logScalingCheckBox.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Left)));
-      this.logScalingCheckBox.AutoSize = true;
-      this.logScalingCheckBox.Location = new System.Drawing.Point(0, 354);
-      this.logScalingCheckBox.Name = "logScalingCheckBox";
-      this.logScalingCheckBox.Size = new System.Drawing.Size(112, 17);
-      this.logScalingCheckBox.TabIndex = 5;
-      this.logScalingCheckBox.Text = "logarithmic scaling";
-      this.logScalingCheckBox.UseVisualStyleBackColor = true;
-      this.logScalingCheckBox.CheckedChanged += new System.EventHandler(this.logScalingCheckBox_CheckedChanged);
-      // 
-      // RunCollectionECDFView
-      // 
-      this.AutoScaleMode = System.Windows.Forms.AutoScaleMode.Inherit;
-      this.Controls.Add(this.logScalingCheckBox);
-      this.Controls.Add(this.groupComboBox);
-      this.Controls.Add(this.label2);
-      this.Controls.Add(this.viewHost);
-      this.Controls.Add(this.label1);
-      this.Controls.Add(this.dataTableComboBox);
-      this.Name = "RunCollectionECDFView";
-      this.Size = new System.Drawing.Size(527, 374);
-      this.ResumeLayout(false);
-      this.PerformLayout();
-
-    }
-
-    #endregion
-
-    private System.Windows.Forms.ComboBox dataTableComboBox;
-    private System.Windows.Forms.Label label1;
-    private MainForm.WindowsForms.ViewHost viewHost;
-    private System.Windows.Forms.Label label2;
-    private System.Windows.Forms.ComboBox groupComboBox;
-    private System.Windows.Forms.CheckBox logScalingCheckBox;
-  }
-}
Index: anches/PerformanceComparison/HeuristicLab.Optimization.Views/3.3/RunCollectionViews/RunCollectionECDFView.cs
===================================================================
--- /branches/PerformanceComparison/HeuristicLab.Optimization.Views/3.3/RunCollectionViews/RunCollectionECDFView.cs	(revision 12802)
+++ 	(revision )
@@ -1,269 +1,0 @@
-﻿#region License Information
-/* HeuristicLab
- * Copyright (C) 2002-2015 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
- *
- * This file is part of HeuristicLab.
- *
- * HeuristicLab is free software: you can redistribute it and/or modify
- * it under the terms of the GNU General Public License as published by
- * the Free Software Foundation, either version 3 of the License, or
- * (at your option) any later version.
- *
- * HeuristicLab is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
- */
-#endregion
-
-using System;
-using System.Collections.Generic;
-using System.ComponentModel;
-using System.Linq;
-using System.Windows.Forms;
-using HeuristicLab.Analysis;
-using HeuristicLab.Collections;
-using HeuristicLab.Common;
-using HeuristicLab.Core.Views;
-using HeuristicLab.MainForm;
-
-namespace HeuristicLab.Optimization.Views {
-  [View("ECDF Performance Comparison")]
-  [Content(typeof(RunCollection), false)]
-  public partial class RunCollectionECDFView : ItemView {
-    private const string AllRuns = "All Runs";
-
-    public new RunCollection Content {
-      get { return (RunCollection)base.Content; }
-      set { base.Content = value; }
-    }
-
-    private bool suppressUpdates;
-    private readonly IndexedDataTable<double> combinedDataTable;
-    public IndexedDataTable<double> CombinedDataTable {
-      get { return combinedDataTable; }
-    }
-
-    public RunCollectionECDFView() {
-      InitializeComponent();
-      combinedDataTable = new IndexedDataTable<double>("Combined DataTable", "A data table containing the ECDF of each of a number of groups.") {
-        VisualProperties = { YAxisTitle = "Proportion of reached targets" }
-      };
-      viewHost.Content = combinedDataTable;
-      suppressUpdates = false;
-    }
-
-    #region Content events
-    protected override void RegisterContentEvents() {
-      base.RegisterContentEvents();
-      Content.ItemsAdded += Content_ItemsAdded;
-      Content.ItemsRemoved += Content_ItemsRemoved;
-      Content.CollectionReset += Content_CollectionReset;
-      Content.UpdateOfRunsInProgressChanged += Content_UpdateOfRunsInProgressChanged;
-      Content.OptimizerNameChanged += Content_AlgorithmNameChanged;
-    }
-    protected override void DeregisterContentEvents() {
-      Content.ItemsAdded -= Content_ItemsAdded;
-      Content.ItemsRemoved -= Content_ItemsRemoved;
-      Content.CollectionReset -= Content_CollectionReset;
-      Content.UpdateOfRunsInProgressChanged -= Content_UpdateOfRunsInProgressChanged;
-      Content.OptimizerNameChanged -= Content_AlgorithmNameChanged;
-      base.DeregisterContentEvents();
-    }
-
-    private void Content_ItemsAdded(object sender, CollectionItemsChangedEventArgs<IRun> e) {
-      if (suppressUpdates) return;
-      if (InvokeRequired) {
-        Invoke(new CollectionItemsChangedEventHandler<IRun>(Content_ItemsAdded), sender, e);
-        return;
-      }
-      UpdateGroupComboBox();
-      UpdateDataTableComboBox();
-      foreach (var run in e.Items)
-        RegisterRunEvents(run);
-    }
-    private void Content_ItemsRemoved(object sender, CollectionItemsChangedEventArgs<IRun> e) {
-      if (suppressUpdates) return;
-      if (InvokeRequired) {
-        Invoke(new CollectionItemsChangedEventHandler<IRun>(Content_ItemsRemoved), sender, e);
-        return;
-      }
-      UpdateGroupComboBox();
-      UpdateDataTableComboBox();
-      foreach (var run in e.Items)
-        DeregisterRunEvents(run);
-    }
-    private void Content_CollectionReset(object sender, CollectionItemsChangedEventArgs<IRun> e) {
-      if (suppressUpdates) return;
-      if (InvokeRequired) {
-        Invoke(new CollectionItemsChangedEventHandler<IRun>(Content_CollectionReset), sender, e);
-        return;
-      }
-      UpdateGroupComboBox();
-      UpdateDataTableComboBox();
-      foreach (var run in e.OldItems)
-        DeregisterRunEvents(run);
-    }
-    private void Content_AlgorithmNameChanged(object sender, EventArgs e) {
-      if (InvokeRequired)
-        Invoke(new EventHandler(Content_AlgorithmNameChanged), sender, e);
-      else UpdateCaption();
-    }
-    private void Content_UpdateOfRunsInProgressChanged(object sender, EventArgs e) {
-      if (InvokeRequired) {
-        Invoke(new EventHandler(Content_UpdateOfRunsInProgressChanged), sender, e);
-        return;
-      }
-      suppressUpdates = Content.UpdateOfRunsInProgress;
-      if (!suppressUpdates) {
-        UpdateDataTableComboBox();
-        UpdateGroupComboBox();
-        UpdateRuns();
-      }
-    }
-
-    private void RegisterRunEvents(IRun run) {
-      run.PropertyChanged += run_PropertyChanged;
-    }
-    private void DeregisterRunEvents(IRun run) {
-      run.PropertyChanged -= run_PropertyChanged;
-    }
-    private void run_PropertyChanged(object sender, PropertyChangedEventArgs e) {
-      if (suppressUpdates) return;
-      if (InvokeRequired) {
-        Invoke((Action<object, PropertyChangedEventArgs>)run_PropertyChanged, sender, e);
-      } else {
-        if (e.PropertyName == "Visible")
-          UpdateRuns();
-      }
-    }
-    #endregion
-
-    protected override void OnContentChanged() {
-      base.OnContentChanged();
-      dataTableComboBox.Items.Clear();
-      groupComboBox.Items.Clear();
-      combinedDataTable.Rows.Clear();
-
-      UpdateCaption();
-      if (Content != null) {
-        UpdateGroupComboBox();
-        UpdateDataTableComboBox();
-      }
-    }
-
-    private void UpdateRuns() {
-      if (InvokeRequired) {
-        Invoke((Action)UpdateRuns);
-        return;
-      }
-      SuspendRepaint();
-      try {
-        combinedDataTable.VisualProperties.XAxisLogScale = false;
-        combinedDataTable.Rows.Clear();
-        var table = (string)dataTableComboBox.SelectedItem;
-        if (string.IsNullOrEmpty(table)) return;
-        var maximum = Content.Select(x => ((IndexedDataTable<double>)x.Results[table]).Rows.First().Values.Max(y => y.Item2)).Max();
-        var minimum = Content.Select(x => ((IndexedDataTable<double>)x.Results[table]).Rows.First().Values.Min(y => y.Item2)).Min();
-        var levels = Enumerable.Range(0, 51).Select(x => maximum - (x / 50.0) * (maximum - minimum)).ToArray();
-        var selectedGroup = (string)groupComboBox.SelectedItem;
-        if (string.IsNullOrEmpty(selectedGroup)) return;
-        List<Tuple<string, List<IRun>>> groupedRuns;
-        if (selectedGroup == AllRuns)
-          groupedRuns = new List<Tuple<string, List<IRun>>> { Tuple.Create(AllRuns, Content.ToList()) };
-        else groupedRuns = (from r in Content
-                            group r by r.Parameters[selectedGroup].ToString() into g
-                            select Tuple.Create(g.Key, g.ToList())).ToList();
-        var xAxisTitles = new HashSet<string>();
-        foreach (var group in groupedRuns) {
-          var hits = new SortedList<double, int>();
-          foreach (var run in group.Item2) {
-            var resultsTable = (IndexedDataTable<double>)run.Results[table];
-            xAxisTitles.Add(resultsTable.VisualProperties.XAxisTitle);
-            var graph = new LinkedList<Tuple<double, double>>(resultsTable.Rows.First().Values);
-            var current = graph.First.Next;
-            // prune convergence graph to obtain first hit times only
-            while (current != null) {
-              if (current.Value.Item2.IsAlmost(current.Previous.Value.Item2)) {
-                var h = current;
-                current = current.Previous;
-                graph.Remove(h);
-              }
-              current = current.Next;
-            }
-            var i = 0;
-            current = graph.First;
-            while (i < levels.Length && current != null) {
-              if (current.Value.Item2 < levels[i]) {
-                if (hits.ContainsKey(current.Value.Item1))
-                  hits[current.Value.Item1]++;
-                else hits[current.Value.Item1] = 1;
-                i++;
-              } else {
-                current = current.Next;
-              }
-            }
-          }
-          var row = new IndexedDataRow<double>(group.Item1) { VisualProperties = { ChartType = DataRowVisualProperties.DataRowChartType.StepLine } };
-          var total = 0.0;
-          foreach (var h in hits) {
-            total += h.Value;
-            row.Values.Add(Tuple.Create(h.Key, total / (group.Item2.Count * levels.Length)));
-          }
-          combinedDataTable.Rows.Add(row);
-        }
-        combinedDataTable.VisualProperties.XAxisTitle = string.Join(" / ", xAxisTitles);
-        combinedDataTable.VisualProperties.XAxisLogScale = logScalingCheckBox.Checked;
-      } finally { ResumeRepaint(true); }
-    }
-
-    private void UpdateGroupComboBox() {
-      string selectedItem = (string)groupComboBox.SelectedItem;
-
-      var groupings = Content.ParameterNames.OrderBy(x => x).ToArray();
-      groupComboBox.Items.Clear();
-      groupComboBox.Items.Add(AllRuns);
-      groupComboBox.Items.AddRange(groupings);
-      if (selectedItem != null && groupComboBox.Items.Contains(selectedItem)) {
-        groupComboBox.SelectedItem = selectedItem;
-      } else if (groupComboBox.Items.Count > 0) {
-        groupComboBox.SelectedItem = groupComboBox.Items[0];
-      }
-    }
-
-    private void UpdateDataTableComboBox() {
-      string selectedItem = (string)dataTableComboBox.SelectedItem;
-
-      dataTableComboBox.Items.Clear();
-      var dataTables = (from run in Content
-                        from result in run.Results
-                        where result.Value is IndexedDataTable<double>
-                        select result.Key).Distinct().ToArray();
-
-      dataTableComboBox.Items.AddRange(dataTables);
-      if (selectedItem != null && dataTableComboBox.Items.Contains(selectedItem)) {
-        dataTableComboBox.SelectedItem = selectedItem;
-      } else if (dataTableComboBox.Items.Count > 0) {
-        dataTableComboBox.SelectedItem = dataTableComboBox.Items[0];
-      }
-    }
-
-    private void UpdateCaption() {
-      Caption = Content != null ? Content.OptimizerName + " ECDF Comparison" : ViewAttribute.GetViewName(GetType());
-    }
-
-    private void groupComboBox_SelectedIndexChanged(object sender, EventArgs e) {
-      UpdateRuns();
-    }
-    private void dataTableComboBox_SelectedIndexChanged(object sender, EventArgs e) {
-      UpdateRuns();
-    }
-
-    private void logScalingCheckBox_CheckedChanged(object sender, EventArgs e) {
-      combinedDataTable.VisualProperties.XAxisLogScale = logScalingCheckBox.Checked;
-    }
-  }
-}
Index: /branches/PerformanceComparison/HeuristicLab.Optimization.Views/3.3/RunCollectionViews/RunCollectionRLDView.Designer.cs
===================================================================
--- /branches/PerformanceComparison/HeuristicLab.Optimization.Views/3.3/RunCollectionViews/RunCollectionRLDView.Designer.cs	(revision 12803)
+++ /branches/PerformanceComparison/HeuristicLab.Optimization.Views/3.3/RunCollectionViews/RunCollectionRLDView.Designer.cs	(revision 12803)
@@ -0,0 +1,149 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2015 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+namespace HeuristicLab.Optimization.Views {
+  partial class RunCollectionRLDView {
+    /// <summary> 
+    /// Required designer variable.
+    /// </summary>
+    private System.ComponentModel.IContainer components = null;
+
+    /// <summary> 
+    /// Clean up any resources being used.
+    /// </summary>
+    /// <param name="disposing">true if managed resources should be disposed; otherwise, false.</param>
+    protected override void Dispose(bool disposing) {
+      if (disposing && (components != null)) {
+        components.Dispose();
+      }
+      base.Dispose(disposing);
+    }
+
+    #region Component Designer generated code
+
+    /// <summary> 
+    /// Required method for Designer support - do not modify 
+    /// the contents of this method with the code editor.
+    /// </summary>
+    private void InitializeComponent() {
+      this.dataTableComboBox = new System.Windows.Forms.ComboBox();
+      this.label1 = new System.Windows.Forms.Label();
+      this.viewHost = new HeuristicLab.MainForm.WindowsForms.ViewHost();
+      this.label2 = new System.Windows.Forms.Label();
+      this.groupComboBox = new System.Windows.Forms.ComboBox();
+      this.logScalingCheckBox = new System.Windows.Forms.CheckBox();
+      this.SuspendLayout();
+      // 
+      // dataTableComboBox
+      // 
+      this.dataTableComboBox.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left) 
+            | System.Windows.Forms.AnchorStyles.Right)));
+      this.dataTableComboBox.DropDownStyle = System.Windows.Forms.ComboBoxStyle.DropDownList;
+      this.dataTableComboBox.FormattingEnabled = true;
+      this.dataTableComboBox.Location = new System.Drawing.Point(69, 30);
+      this.dataTableComboBox.Name = "dataTableComboBox";
+      this.dataTableComboBox.Size = new System.Drawing.Size(455, 21);
+      this.dataTableComboBox.TabIndex = 0;
+      this.dataTableComboBox.SelectedIndexChanged += new System.EventHandler(this.dataTableComboBox_SelectedIndexChanged);
+      // 
+      // label1
+      // 
+      this.label1.AutoSize = true;
+      this.label1.Location = new System.Drawing.Point(3, 33);
+      this.label1.Name = "label1";
+      this.label1.Size = new System.Drawing.Size(60, 13);
+      this.label1.TabIndex = 1;
+      this.label1.Text = "DataTable:";
+      // 
+      // viewHost
+      // 
+      this.viewHost.Anchor = ((System.Windows.Forms.AnchorStyles)((((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom) 
+            | System.Windows.Forms.AnchorStyles.Left) 
+            | System.Windows.Forms.AnchorStyles.Right)));
+      this.viewHost.Caption = "View";
+      this.viewHost.Content = null;
+      this.viewHost.Enabled = false;
+      this.viewHost.Location = new System.Drawing.Point(4, 57);
+      this.viewHost.Name = "viewHost";
+      this.viewHost.ReadOnly = false;
+      this.viewHost.Size = new System.Drawing.Size(520, 291);
+      this.viewHost.TabIndex = 2;
+      this.viewHost.ViewsLabelVisible = true;
+      this.viewHost.ViewType = null;
+      // 
+      // label2
+      // 
+      this.label2.AutoSize = true;
+      this.label2.Location = new System.Drawing.Point(3, 6);
+      this.label2.Name = "label2";
+      this.label2.Size = new System.Drawing.Size(39, 13);
+      this.label2.TabIndex = 3;
+      this.label2.Text = "Group:";
+      // 
+      // groupComboBox
+      // 
+      this.groupComboBox.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left) 
+            | System.Windows.Forms.AnchorStyles.Right)));
+      this.groupComboBox.DropDownStyle = System.Windows.Forms.ComboBoxStyle.DropDownList;
+      this.groupComboBox.FormattingEnabled = true;
+      this.groupComboBox.Location = new System.Drawing.Point(69, 3);
+      this.groupComboBox.Name = "groupComboBox";
+      this.groupComboBox.Size = new System.Drawing.Size(455, 21);
+      this.groupComboBox.TabIndex = 4;
+      this.groupComboBox.SelectedIndexChanged += new System.EventHandler(this.groupComboBox_SelectedIndexChanged);
+      // 
+      // logScalingCheckBox
+      // 
+      this.logScalingCheckBox.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Left)));
+      this.logScalingCheckBox.AutoSize = true;
+      this.logScalingCheckBox.Location = new System.Drawing.Point(0, 354);
+      this.logScalingCheckBox.Name = "logScalingCheckBox";
+      this.logScalingCheckBox.Size = new System.Drawing.Size(112, 17);
+      this.logScalingCheckBox.TabIndex = 5;
+      this.logScalingCheckBox.Text = "logarithmic scaling";
+      this.logScalingCheckBox.UseVisualStyleBackColor = true;
+      this.logScalingCheckBox.CheckedChanged += new System.EventHandler(this.logScalingCheckBox_CheckedChanged);
+      // 
+      // RunCollectionECDFView
+      // 
+      this.AutoScaleMode = System.Windows.Forms.AutoScaleMode.Inherit;
+      this.Controls.Add(this.logScalingCheckBox);
+      this.Controls.Add(this.groupComboBox);
+      this.Controls.Add(this.label2);
+      this.Controls.Add(this.viewHost);
+      this.Controls.Add(this.label1);
+      this.Controls.Add(this.dataTableComboBox);
+      this.Name = "RunCollectionECDFView";
+      this.Size = new System.Drawing.Size(527, 374);
+      this.ResumeLayout(false);
+      this.PerformLayout();
+
+    }
+
+    #endregion
+
+    private System.Windows.Forms.ComboBox dataTableComboBox;
+    private System.Windows.Forms.Label label1;
+    private MainForm.WindowsForms.ViewHost viewHost;
+    private System.Windows.Forms.Label label2;
+    private System.Windows.Forms.ComboBox groupComboBox;
+    private System.Windows.Forms.CheckBox logScalingCheckBox;
+  }
+}
Index: /branches/PerformanceComparison/HeuristicLab.Optimization.Views/3.3/RunCollectionViews/RunCollectionRLDView.cs
===================================================================
--- /branches/PerformanceComparison/HeuristicLab.Optimization.Views/3.3/RunCollectionViews/RunCollectionRLDView.cs	(revision 12803)
+++ /branches/PerformanceComparison/HeuristicLab.Optimization.Views/3.3/RunCollectionViews/RunCollectionRLDView.cs	(revision 12803)
@@ -0,0 +1,269 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2015 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System;
+using System.Collections.Generic;
+using System.ComponentModel;
+using System.Linq;
+using System.Windows.Forms;
+using HeuristicLab.Analysis;
+using HeuristicLab.Collections;
+using HeuristicLab.Common;
+using HeuristicLab.Core.Views;
+using HeuristicLab.MainForm;
+
+namespace HeuristicLab.Optimization.Views {
+  [View("Run-length Distribution View")]
+  [Content(typeof(RunCollection), false)]
+  public partial class RunCollectionRLDView : ItemView {
+    private const string AllRuns = "All Runs";
+
+    public new RunCollection Content {
+      get { return (RunCollection)base.Content; }
+      set { base.Content = value; }
+    }
+
+    private bool suppressUpdates;
+    private readonly IndexedDataTable<double> combinedDataTable;
+    public IndexedDataTable<double> CombinedDataTable {
+      get { return combinedDataTable; }
+    }
+
+    public RunCollectionRLDView() {
+      InitializeComponent();
+      combinedDataTable = new IndexedDataTable<double>("Combined DataTable", "A data table containing the ECDF of each of a number of groups.") {
+        VisualProperties = { YAxisTitle = "Proportion of reached targets" }
+      };
+      viewHost.Content = combinedDataTable;
+      suppressUpdates = false;
+    }
+
+    #region Content events
+    protected override void RegisterContentEvents() {
+      base.RegisterContentEvents();
+      Content.ItemsAdded += Content_ItemsAdded;
+      Content.ItemsRemoved += Content_ItemsRemoved;
+      Content.CollectionReset += Content_CollectionReset;
+      Content.UpdateOfRunsInProgressChanged += Content_UpdateOfRunsInProgressChanged;
+      Content.OptimizerNameChanged += Content_AlgorithmNameChanged;
+    }
+    protected override void DeregisterContentEvents() {
+      Content.ItemsAdded -= Content_ItemsAdded;
+      Content.ItemsRemoved -= Content_ItemsRemoved;
+      Content.CollectionReset -= Content_CollectionReset;
+      Content.UpdateOfRunsInProgressChanged -= Content_UpdateOfRunsInProgressChanged;
+      Content.OptimizerNameChanged -= Content_AlgorithmNameChanged;
+      base.DeregisterContentEvents();
+    }
+
+    private void Content_ItemsAdded(object sender, CollectionItemsChangedEventArgs<IRun> e) {
+      if (suppressUpdates) return;
+      if (InvokeRequired) {
+        Invoke(new CollectionItemsChangedEventHandler<IRun>(Content_ItemsAdded), sender, e);
+        return;
+      }
+      UpdateGroupComboBox();
+      UpdateDataTableComboBox();
+      foreach (var run in e.Items)
+        RegisterRunEvents(run);
+    }
+    private void Content_ItemsRemoved(object sender, CollectionItemsChangedEventArgs<IRun> e) {
+      if (suppressUpdates) return;
+      if (InvokeRequired) {
+        Invoke(new CollectionItemsChangedEventHandler<IRun>(Content_ItemsRemoved), sender, e);
+        return;
+      }
+      UpdateGroupComboBox();
+      UpdateDataTableComboBox();
+      foreach (var run in e.Items)
+        DeregisterRunEvents(run);
+    }
+    private void Content_CollectionReset(object sender, CollectionItemsChangedEventArgs<IRun> e) {
+      if (suppressUpdates) return;
+      if (InvokeRequired) {
+        Invoke(new CollectionItemsChangedEventHandler<IRun>(Content_CollectionReset), sender, e);
+        return;
+      }
+      UpdateGroupComboBox();
+      UpdateDataTableComboBox();
+      foreach (var run in e.OldItems)
+        DeregisterRunEvents(run);
+    }
+    private void Content_AlgorithmNameChanged(object sender, EventArgs e) {
+      if (InvokeRequired)
+        Invoke(new EventHandler(Content_AlgorithmNameChanged), sender, e);
+      else UpdateCaption();
+    }
+    private void Content_UpdateOfRunsInProgressChanged(object sender, EventArgs e) {
+      if (InvokeRequired) {
+        Invoke(new EventHandler(Content_UpdateOfRunsInProgressChanged), sender, e);
+        return;
+      }
+      suppressUpdates = Content.UpdateOfRunsInProgress;
+      if (!suppressUpdates) {
+        UpdateDataTableComboBox();
+        UpdateGroupComboBox();
+        UpdateRuns();
+      }
+    }
+
+    private void RegisterRunEvents(IRun run) {
+      run.PropertyChanged += run_PropertyChanged;
+    }
+    private void DeregisterRunEvents(IRun run) {
+      run.PropertyChanged -= run_PropertyChanged;
+    }
+    private void run_PropertyChanged(object sender, PropertyChangedEventArgs e) {
+      if (suppressUpdates) return;
+      if (InvokeRequired) {
+        Invoke((Action<object, PropertyChangedEventArgs>)run_PropertyChanged, sender, e);
+      } else {
+        if (e.PropertyName == "Visible")
+          UpdateRuns();
+      }
+    }
+    #endregion
+
+    protected override void OnContentChanged() {
+      base.OnContentChanged();
+      dataTableComboBox.Items.Clear();
+      groupComboBox.Items.Clear();
+      combinedDataTable.Rows.Clear();
+
+      UpdateCaption();
+      if (Content != null) {
+        UpdateGroupComboBox();
+        UpdateDataTableComboBox();
+      }
+    }
+
+    private void UpdateRuns() {
+      if (InvokeRequired) {
+        Invoke((Action)UpdateRuns);
+        return;
+      }
+      SuspendRepaint();
+      try {
+        combinedDataTable.VisualProperties.XAxisLogScale = false;
+        combinedDataTable.Rows.Clear();
+        var table = (string)dataTableComboBox.SelectedItem;
+        if (string.IsNullOrEmpty(table)) return;
+        var maximum = Content.Select(x => ((IndexedDataTable<double>)x.Results[table]).Rows.First().Values.Max(y => y.Item2)).Max();
+        var minimum = Content.Select(x => ((IndexedDataTable<double>)x.Results[table]).Rows.First().Values.Min(y => y.Item2)).Min();
+        var levels = Enumerable.Range(0, 51).Select(x => maximum - (x / 50.0) * (maximum - minimum)).ToArray();
+        var selectedGroup = (string)groupComboBox.SelectedItem;
+        if (string.IsNullOrEmpty(selectedGroup)) return;
+        List<Tuple<string, List<IRun>>> groupedRuns;
+        if (selectedGroup == AllRuns)
+          groupedRuns = new List<Tuple<string, List<IRun>>> { Tuple.Create(AllRuns, Content.ToList()) };
+        else groupedRuns = (from r in Content
+                            group r by r.Parameters[selectedGroup].ToString() into g
+                            select Tuple.Create(g.Key, g.ToList())).ToList();
+        var xAxisTitles = new HashSet<string>();
+        foreach (var group in groupedRuns) {
+          var hits = new SortedList<double, int>();
+          foreach (var run in group.Item2) {
+            var resultsTable = (IndexedDataTable<double>)run.Results[table];
+            xAxisTitles.Add(resultsTable.VisualProperties.XAxisTitle);
+            var graph = new LinkedList<Tuple<double, double>>(resultsTable.Rows.First().Values);
+            var current = graph.First.Next;
+            // prune convergence graph to obtain first hit times only
+            while (current != null) {
+              if (current.Value.Item2.IsAlmost(current.Previous.Value.Item2)) {
+                var h = current;
+                current = current.Previous;
+                graph.Remove(h);
+              }
+              current = current.Next;
+            }
+            var i = 0;
+            current = graph.First;
+            while (i < levels.Length && current != null) {
+              if (current.Value.Item2 < levels[i]) {
+                if (hits.ContainsKey(current.Value.Item1))
+                  hits[current.Value.Item1]++;
+                else hits[current.Value.Item1] = 1;
+                i++;
+              } else {
+                current = current.Next;
+              }
+            }
+          }
+          var row = new IndexedDataRow<double>(group.Item1) { VisualProperties = { ChartType = DataRowVisualProperties.DataRowChartType.StepLine } };
+          var total = 0.0;
+          foreach (var h in hits) {
+            total += h.Value;
+            row.Values.Add(Tuple.Create(h.Key, total / (group.Item2.Count * levels.Length)));
+          }
+          combinedDataTable.Rows.Add(row);
+        }
+        combinedDataTable.VisualProperties.XAxisTitle = string.Join(" / ", xAxisTitles);
+        combinedDataTable.VisualProperties.XAxisLogScale = logScalingCheckBox.Checked;
+      } finally { ResumeRepaint(true); }
+    }
+
+    private void UpdateGroupComboBox() {
+      string selectedItem = (string)groupComboBox.SelectedItem;
+
+      var groupings = Content.ParameterNames.OrderBy(x => x).ToArray();
+      groupComboBox.Items.Clear();
+      groupComboBox.Items.Add(AllRuns);
+      groupComboBox.Items.AddRange(groupings);
+      if (selectedItem != null && groupComboBox.Items.Contains(selectedItem)) {
+        groupComboBox.SelectedItem = selectedItem;
+      } else if (groupComboBox.Items.Count > 0) {
+        groupComboBox.SelectedItem = groupComboBox.Items[0];
+      }
+    }
+
+    private void UpdateDataTableComboBox() {
+      string selectedItem = (string)dataTableComboBox.SelectedItem;
+
+      dataTableComboBox.Items.Clear();
+      var dataTables = (from run in Content
+                        from result in run.Results
+                        where result.Value is IndexedDataTable<double>
+                        select result.Key).Distinct().ToArray();
+
+      dataTableComboBox.Items.AddRange(dataTables);
+      if (selectedItem != null && dataTableComboBox.Items.Contains(selectedItem)) {
+        dataTableComboBox.SelectedItem = selectedItem;
+      } else if (dataTableComboBox.Items.Count > 0) {
+        dataTableComboBox.SelectedItem = dataTableComboBox.Items[0];
+      }
+    }
+
+    private void UpdateCaption() {
+      Caption = Content != null ? Content.OptimizerName + " RLD View" : ViewAttribute.GetViewName(GetType());
+    }
+
+    private void groupComboBox_SelectedIndexChanged(object sender, EventArgs e) {
+      UpdateRuns();
+    }
+    private void dataTableComboBox_SelectedIndexChanged(object sender, EventArgs e) {
+      UpdateRuns();
+    }
+
+    private void logScalingCheckBox_CheckedChanged(object sender, EventArgs e) {
+      combinedDataTable.VisualProperties.XAxisLogScale = logScalingCheckBox.Checked;
+    }
+  }
+}
Index: /branches/PerformanceComparison/HeuristicLab.Optimization/3.3/Algorithms/BasicAlgorithm.cs
===================================================================
--- /branches/PerformanceComparison/HeuristicLab.Optimization/3.3/Algorithms/BasicAlgorithm.cs	(revision 12802)
+++ /branches/PerformanceComparison/HeuristicLab.Optimization/3.3/Algorithms/BasicAlgorithm.cs	(revision 12803)
@@ -24,5 +24,4 @@
 using System.Threading.Tasks;
 using HeuristicLab.Common;
-using HeuristicLab.Data;
 using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
 
@@ -36,12 +35,4 @@
     public override ResultCollection Results {
       get { return results; }
-    }
-
-    protected override void OnExecutionTimeChanged() {
-      base.OnExecutionTimeChanged();
-      IResult result;
-      if (!Results.TryGetValue("Execution Time", out result))
-        Results.Add(new Result("Execution Time", new TimeSpanValue(ExecutionTime)));
-      else ((TimeSpanValue)result.Value).Value = ExecutionTime;
     }
 
Index: /branches/PerformanceComparison/HeuristicLab.Optimization/3.3/Algorithms/EngineAlgorithm.cs
===================================================================
--- /branches/PerformanceComparison/HeuristicLab.Optimization/3.3/Algorithms/EngineAlgorithm.cs	(revision 12802)
+++ /branches/PerformanceComparison/HeuristicLab.Optimization/3.3/Algorithms/EngineAlgorithm.cs	(revision 12803)
@@ -22,8 +22,6 @@
 using System;
 using System.Linq;
-using System.Reflection;
 using HeuristicLab.Common;
 using HeuristicLab.Core;
-using HeuristicLab.Data;
 using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
 using HeuristicLab.PluginInfrastructure;
@@ -73,12 +71,4 @@
     }
 
-    protected override void OnExecutionTimeChanged() {
-      base.OnExecutionTimeChanged();
-      IResult result;
-      if (!Results.TryGetValue("Execution Time", out result))
-        Results.Add(new Result("Execution Time", new TimeSpanValue(ExecutionTime)));
-      else ((TimeSpanValue)result.Value).Value = ExecutionTime;
-    }
-
     public override ResultCollection Results {
       get {
